"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var GraphParser =
/*#__PURE__*/
function () {
  function GraphParser(graph, models) {
    _classCallCheck(this, GraphParser);

    this.graph = graph;
    this.models = models;
  }

  _createClass(GraphParser, [{
    key: "parse",
    value: function parse(graph) {
      var _this = this;

      Object.entries(graph).forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            key = _ref2[0],
            value = _ref2[1];

        graph[key] = _this.parseEntry(value);
      });
      var object = graph.__typename !== undefined ? this.parseModel(graph) : graph;
      delete object.__typename;
      return object;
    }
  }, {
    key: "parseEntry",
    value: function parseEntry(value) {
      if (value === null) return null;

      if (value instanceof Object && !Array.isArray(value)) {
        return this.parse(value);
      }

      if (Array.isArray(value)) {
        return this.parseCollection(value);
      }

      if (value.__typename !== undefined) {
        return this.parseModel(value);
      }

      return value;
    }
  }, {
    key: "parseCollection",
    value: function parseCollection(collection) {
      var _this2 = this;

      var coll = [];
      collection.forEach(function (item) {
        if (item instanceof Object) {
          coll.push(_this2.parse(item));
        }
      });
      return coll;
    }
  }, {
    key: "parseModel",
    value: function parseModel(attributes) {
      var model = this.models[attributes.__typename];

      try {
        var object = new model(attributes);
        delete object.__typename;
        return object;
      } catch (e) {
        // console.warn('Model not found: ' + attributes.__typename)
        return attributes;
      }
    }
  }], [{
    key: "map",
    value: function map(graph, models) {
      return new this(graph, models).parse(graph);
    }
  }]);

  return GraphParser;
}();

exports.default = GraphParser;