"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _GraphParser = _interopRequireDefault(require("./GraphParser"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Model =
/*#__PURE__*/
function () {
  function Model(attributes) {
    _classCallCheck(this, Model);

    if (attributes && attributes.__typename) {
      Object.assign(this, attributes);
    } else {
      Object.assign(this, this.constructor.defaults, attributes);
    }
  }
  /**
   * Setup Apollo Provider and pre-load all models
   * 
   * @param {apolloProvider} options 
   */


  _createClass(Model, [{
    key: "primaryKey",
    value: function primaryKey() {
      return 'id';
    }
  }, {
    key: "getPrimaryKey",
    value: function getPrimaryKey() {
      return this[this.primaryKey()];
    }
  }, {
    key: "hasId",
    value: function hasId() {
      var id = this.getPrimaryKey();
      return this.isValidId(id);
    }
  }, {
    key: "isValidId",
    value: function isValidId(id) {
      return id !== undefined && id !== 0 && id !== '' && id !== null;
    }
  }, {
    key: "save",
    value: function () {
      var _save = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var operation, response, object, graph;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                // TODO exception if methods are not implemented on BaseModel
                operation = this.hasId() ? this.UPDATE_MUTATION() : this.CREATE_MUTATION();
                _context.next = 4;
                return this.$apollo.mutate({
                  mutation: operation.mutation,
                  variables: operation.variables
                });

              case 4:
                response = _context.sent;
                object = {};
                Object.assign(object, Object.entries(response.data)[0][1]);
                graph = _GraphParser.default.map(object, this.$models);
                Object.assign(this, {}, graph);
                return _context.abrupt("return", graph);

              case 12:
                _context.prev = 12;
                _context.t0 = _context["catch"](0);
                console.log({
                  error: _context.t0
                });
                throw this.convertError(_context.t0);

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 12]]);
      }));

      return function save() {
        return _save.apply(this, arguments);
      };
    }()
  }, {
    key: "delete",
    value: function () {
      var _delete2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var operation;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                operation = this.DELETE_MUTATION();
                _context2.next = 4;
                return this.$apollo.mutate({
                  mutation: operation.mutation,
                  variables: operation.variables
                });

              case 4:
                _context2.next = 9;
                break;

              case 6:
                _context2.prev = 6;
                _context2.t0 = _context2["catch"](0);
                throw this.convertError(_context2.t0);

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[0, 6]]);
      }));

      return function _delete() {
        return _delete2.apply(this, arguments);
      };
    }()
  }, {
    key: "convertError",
    value: function convertError(error) {
      var exception = {};
      exception.message = error.graphQLErrors[0].message;

      if (error.graphQLErrors[0].validation) {
        exception.errors = Object.assign({}, error.graphQLErrors[0].validation);
      }

      return exception;
    }
  }, {
    key: "$apollo",
    get: function get() {
      return Model.$apollo;
    }
  }, {
    key: "$models",
    get: function get() {
      return Model.$models;
    }
  }], [{
    key: "setup",
    value: function setup(options) {
      // Pre-load all models
      var models = [];

      var r = require.context('@/models', true, /\.js$/);

      r.keys().forEach(function (key) {
        return models[key.replace(/(\.\/|\.js)/g, "")] = r(key).default;
      });
      Model.$models = models; // Override default $query option to transform response into Models

      options.apolloProvider.defaultOptions = {
        $query: {
          update: function update(data) {
            return _GraphParser.default.map(Object.entries(data)[0][1], Model.$models);
          }
        }
      };
      Model.$apollo = options.apolloProvider.defaultClient;
    }
  }, {
    key: "find",
    value: function () {
      var _find = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(id) {
        var response;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.$apollo.query({
                  query: this.FIND_QUERY,
                  variables: {
                    id: id
                  }
                });

              case 2:
                response = _context3.sent;
                return _context3.abrupt("return", _GraphParser.default.map(Object.entries(response.data)[0][1], this.$models));

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function find(_x) {
        return _find.apply(this, arguments);
      };
    }()
  }, {
    key: "all",
    value: function () {
      var _all = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4() {
        var variables,
            response,
            _args4 = arguments;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                variables = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : {};
                _context4.next = 3;
                return this.$apollo.query({
                  query: this.ALL_QUERY,
                  variables: variables
                });

              case 3:
                response = _context4.sent;
                return _context4.abrupt("return", _GraphParser.default.map(Object.entries(response.data)[0][1], this.$models));

              case 5:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      return function all() {
        return _all.apply(this, arguments);
      };
    }()
  }, {
    key: "query",
    value: function () {
      var _query2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5(_query, variables, options) {
        var response;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.$apollo.query({
                  query: _query,
                  variables: variables
                });

              case 2:
                response = _context5.sent;
                return _context5.abrupt("return", _GraphParser.default.map(Object.entries(response.data)[0][1], this.$models));

              case 4:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      return function query(_x2, _x3, _x4) {
        return _query2.apply(this, arguments);
      };
    }()
  }]);

  return Model;
}();

exports.default = Model;

_defineProperty(Model, "defaults", {});